{**********************************}
{* Main unit for Euro application *}
{**********************************}

unit euro_u1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus, StdCtrls, ExtCtrls, Grids;

type
  TCoinsImages = array[1..20] of TImage;
  TCoinsValues = array[1..20] of Integer;
  {********}
  { TfEuro }
  {********}
  TfEuro = class(TForm)
    mMenu: TMainMenu;
    mGame, mGameNew, mGameExit: TMenuItem;
    mSettings, mSettingsAmount, mSettingsCoins, MenuItem1, mSettingsShow: TMenuItem;
    mSettingsAmount50, mSettingsAmount100, mSettingsAmount200, mSettingsAmount500: TMenuItem;
    mSettingsCoins5, mSettingsCoins10, mSettingsCoins15, mSettingsCoins20: TMenuItem;
    mHelp, mHelpAbout: TMenuItem;
    StaticText1: TStaticText;
    Memo1: TMemo;
    Shape1, Shape2: TShape;
    imCents1, imCents2, imCents5: TImage;
    imCents10, imCents20, imCents50: TImage;
    imEuros1, imEuros2: TImage;
    imCoins1, imCoins2, imCoins3, imCoins4, imCoins5, imCoins6, imCoins7: TImage;
    imCoins8, imCoins9, imCoins10, imCoins11, imCoins12, imCoins13, imCoins14: TImage;
    imCoins15, imCoins16, imCoins17, imCoins18, imCoins19, imCoins20: TImage;
    Label1, Label2, Label3: TLabel;
    laUnit: TLabel;
    edCoins: TEdit;
    edAmount: TEdit;
    edUAmount: TEdit;
    sgEval: TStringGrid;
    imEval: TImage;
    btStart: TButton;
    btDone: TButton;
    procedure FormCreate(Sender: TObject);
    procedure mGameNewClick(Sender: TObject);
    procedure mGameExitClick(Sender: TObject);
    procedure mSettingsAmount50Click(Sender: TObject);
    procedure mSettingsAmount100Click(Sender: TObject);
    procedure mSettingsAmount200Click(Sender: TObject);
    procedure mSettingsAmount500Click(Sender: TObject);
    procedure mSettingsCoins5Click(Sender: TObject);
    procedure mSettingsCoins10Click(Sender: TObject);
    procedure mSettingsCoins15Click(Sender: TObject);
    procedure mSettingsCoins20Click(Sender: TObject);
    procedure mSettingsShowClick(Sender: TObject);
    procedure mHelpAboutClick(Sender: TObject);
    procedure btStartClick(Sender: TObject);
    procedure btDoneClick(Sender: TObject);
    procedure imCents1Click(Sender: TObject);
    procedure imCents2Click(Sender: TObject);
    procedure imCents5Click(Sender: TObject);
    procedure imCents10Click(Sender: TObject);
    procedure imCents20Click(Sender: TObject);
    procedure imCents50Click(Sender: TObject);
    procedure imEuros1Click(Sender: TObject);
    procedure imEuros2Click(Sender: TObject);
    procedure imCoins1Click(Sender: TObject);
    procedure imCoins2Click(Sender: TObject);
    procedure imCoins3Click(Sender: TObject);
    procedure imCoins4Click(Sender: TObject);
    procedure imCoins5Click(Sender: TObject);
    procedure imCoins6Click(Sender: TObject);
    procedure imCoins7Click(Sender: TObject);
    procedure imCoins8Click(Sender: TObject);
    procedure imCoins9Click(Sender: TObject);
    procedure imCoins10Click(Sender: TObject);
    procedure imCoins11Click(Sender: TObject);
    procedure imCoins12Click(Sender: TObject);
    procedure imCoins13Click(Sender: TObject);
    procedure imCoins14Click(Sender: TObject);
    procedure imCoins15Click(Sender: TObject);
    procedure imCoins16Click(Sender: TObject);
    procedure imCoins17Click(Sender: TObject);
    procedure imCoins18Click(Sender: TObject);
    procedure imCoins19Click(Sender: TObject);
    procedure imCoins20Click(Sender: TObject);
  private
    iMaxAmount, iMaxCoins, iMinCoins, iCoins, iUserCoins, iAmount, iUserAmount, iQuestion, iCorrect: Integer;
    bSettingsChanged: Boolean;
    aCoins: array[1..20] of Integer;
    aCoinsValues: TCoinsValues;
    imCoins: TCoinsImages;
  end;

const
  CoinsValues: array[0..7] of Integer = (
    1, 2, 5, 10, 20, 50, 100, 200
  );

var
  fEuro: TfEuro;

implementation

{$R *.lfm}

{ Format number for grid display (right-align) }

function GFormat(N: Integer): string;

var
  SN: string;

begin
  SN := ' ' + IntToStr(N);
  if N < 10 then
    SN := '  ' + SN
  else if N < 100 then
    SN := ' ' + SN;
  GFormat := SN;
end;

{ Start a new game }

procedure NewGame(out MaxAmount, MaxCoins, MinCoins, Question, Correct: Integer; var Coins: TCoinsImages);

var
  I: Integer;

begin
  fEuro.edCoins.Text := ''; fEuro.edAmount.Text := '';
  for I := 1 to 20 do
    Coins[I].Visible := False;                                                 // remove all coins by making them invisible
  fEuro.edUAmount.Text := '';
  for I := 0 to 3 do
    fEuro.sgEval.Cells[1, I] := '';
  fEuro.imEval.Visible := False;
  // Get selected maximum amount (settings now becoming active)
  if fEuro.mSettingsAmount50.Checked then
    MaxAmount := 50
  else if fEuro.mSettingsAmount100.Checked then
    MaxAmount := 100
  else if fEuro.mSettingsAmount200.Checked then
    MaxAmount := 200
  else if fEuro.mSettingsAmount500.Checked then
    MaxAmount := 500;
  // Get selected minimum and maximum of coins (settings now becoming active)
  if fEuro.mSettingsCoins5.Checked then begin
    MaxCoins := 5; MinCoins := 3;
  end
  else if fEuro.mSettingsCoins10.Checked then begin
    MaxCoins := 10; MinCoins := 5;
  end
  else if fEuro.mSettingsCoins15.Checked then begin
    MaxCoins := 15; MinCoins := 8;
  end
  else if fEuro.mSettingsCoins20.Checked then begin
    MaxCoins := 20; MinCoins := 10;
  end;
  Question := 0; Correct := 0;
  fEuro.btStart.Caption := 'Start';
  fEuro.btDone.Enabled := False;
end;

{ Display amount so far value }

procedure DisplayAmount(Amount, UserAmount: Integer);

begin
  // Display as cents or euros, depending on amount to reach
  if Amount < 100 then
    fEuro.edUAmount.Text := FloatToStr(UserAmount)
  else
    fEuro.edUAmount.Text := FloatToStrF(UserAmount / 100, ffFixed, 0, 2);
  // Use colors to indicate if amount so far is equal to or less/greater than value to reach
  if UserAmount = Amount then
    fEuro.edUAmount.Font.Color := clLime
  else if UserAmount < Amount then
    fEuro.edUAmount.Font.Color := clYellow
  else
    fEuro.edUAmount.Font.Color := clRed;
end;

{ Coin selection: Display the coin, that the user clicked, in the left box (user answer coins) }

procedure CoinClick(Amount, NCoins, CoinValue: Integer; var UserNCoins, UserAmount: Integer; var Values: TCoinsValues; var Coins: TCoinsImages);

var
  I: Integer;
  Found: Boolean;
  Pic: TPicture;

// The procedure also saves the selected coin's value, the number of coins used and the total amount so far

begin
  // If user tries to use more coins than indicated, display error message
  if UserNCoins + 1 > NCoins then
    MessageDlg('Eingabefehler', 'Die Anzahl der zu verwendenden Münzen ist ' + IntToStr(NCoins), mtError, [mbOK], 0)
  // Otherwise, proceed...
  else begin
    // Determine picture of actual coin
    case CoinValue of
        1: Pic := fEuro.imCents1.Picture;
        2: Pic := fEuro.imCents2.Picture;
        5: Pic := fEuro.imCents5.Picture;
       10: Pic := fEuro.imCents10.Picture;
       20: Pic := fEuro.imCents20.Picture;
       50: Pic := fEuro.imCents50.Picture;
      100: Pic := fEuro.imEuros1.Picture;
      200: Pic := fEuro.imEuros2.Picture;
    end;
    // Display coin at first free place in left box
    I := 1; Found := False;
    repeat
      if not Coins[I].Visible then begin                                       // an invisible coin indicates a free place
        Coins[I].Picture := Pic;                                               // actual coin's picture
        Coins[I].Visible := True;                                              // display the coin by making it visible
        Values[I] := CoinValue;                                                // save coin value (this is needed for the case the user removes the coin later)
        Found := True;
      end;
      Inc(I);
    until Found or (I > 20);
    // New number of coins used and new money amount
    Inc(UserNCoins); UserAmount += CoinValue;
    // Display amount so far (if this options has beem selected)
    if fEuro.mSettingsShow.Checked then
      DisplayAmount(Amount, UserAmount);
  end;
end;

{ Coin removal: Remove the coin clicked by the user by making it invisible }

procedure UserCoinClick(Amount, XCoin: Integer; var UserCoins, UserAmount: Integer; var Values: TCoinsValues; var imCoins: TCoinsImages);

// The procedure also saves the number of coins used and the total amount so far

begin
  if imCoins[XCoin].Visible then begin                                         // if there actually is a coin...
    // Remove coin (by making it invisible)
    imCoins[XCoin].Visible := False;
    // New number of coins and new money amount
    Dec(UserCoins);
    UserAmount -= Values[XCoin]; Values[XCoin] := 0;
    // Display amount so far (if this options has beem selected)
    if fEuro.mSettingsShow.Checked then
      DisplayAmount(Amount, UserAmount);
  end;
end;

{ Update evaluation values }

procedure UpdateEval(Question, Correct: Integer);

begin
  fEuro.sgEval.Cells[1, 0] := GFormat(Question);
  fEuro.sgEval.Cells[1, 1] := GFormat(Correct);
  fEuro.sgEval.Cells[1, 2] := GFormat(Question - Correct);
  fEuro.sgEval.Cells[1, 3] := GFormat(Round(100 * Correct / Question)) + '%';
end;

{********}
{ TfEuro }
{********}

{ Application start: Initialisation }

procedure TfEuro.FormCreate(Sender: TObject);

begin
  // Create array with coin images (left box)
  imCoins[1]  := imCoins1;  imCoins[2]  := imCoins2;  imCoins[3]  := imCoins3;  imCoins[4]  := imCoins4;  imCoins[5] := imCoins5;
  imCoins[6]  := imCoins6;  imCoins[7]  := imCoins7;  imCoins[8]  := imCoins8;  imCoins[9]  := imCoins9;  imCoins[10] := imCoins10;
  imCoins[11] := imCoins11; imCoins[12] := imCoins12; imCoins[13] := imCoins13; imCoins[14] := imCoins14; imCoins[15] := imCoins15;
  imCoins[16] := imCoins16; imCoins[17] := imCoins17; imCoins[18] := imCoins18; imCoins[19] := imCoins19; imCoins[20] := imCoins20;
  // Start a new game
  NewGame(iMaxAmount, iMaxCoins, iMinCoins, iQuestion, iCorrect, imCoins); bSettingsChanged := True;
  Randomize;
end;

{ Menu item "Spiel > Neu": Start a new game }

procedure TfEuro.mGameNewClick(Sender: TObject);

begin
  NewGame(iMaxAmount, iMaxCoins, iMinCoins, iQuestion, iCorrect, imCoins); bSettingsChanged := True;
end;

{ Menu item "Spiel > Beenden": Exit application }

procedure TfEuro.mGameExitClick(Sender: TObject);

begin
  Close;
end;

{ Menu items "Einstellungen > Maximale Geldsumme > ...": Choose maximum money amount }

procedure TfEuro.mSettingsAmount50Click(Sender: TObject);

begin
  if not mSettingsAmount50.Checked then begin
    mSettingsAmount50.Checked  := True;
    mSettingsAmount100.Checked := False;
    mSettingsAmount200.Checked := False;
    mSettingsAmount500.Checked := False;
    bSettingsChanged := False;                                                 // note that new settings have not yet been applied
  end;
end;

procedure TfEuro.mSettingsAmount100Click(Sender: TObject);

begin
  if not mSettingsAmount100.Checked then begin
    mSettingsAmount50.Checked  := False;
    mSettingsAmount100.Checked := True;
    mSettingsAmount200.Checked := False;
    mSettingsAmount500.Checked := False;
    bSettingsChanged := False;
  end;
end;

procedure TfEuro.mSettingsAmount200Click(Sender: TObject);

begin
  if not mSettingsAmount200.Checked then begin
    mSettingsAmount50.Checked  := False;
    mSettingsAmount100.Checked := False;
    mSettingsAmount200.Checked := True;
    mSettingsAmount500.Checked := False;
    bSettingsChanged := False;
  end;
end;

procedure TfEuro.mSettingsAmount500Click(Sender: TObject);

begin
  if not mSettingsAmount500.Checked then begin
    mSettingsAmount50.Checked  := False;
    mSettingsAmount100.Checked := False;
    mSettingsAmount200.Checked := False;
    mSettingsAmount500.Checked := True;
    bSettingsChanged := False;
  end;
end;

{ Menu items "Einstellungen > Anzahl der Münzen > ...": Choose minimum and maximum of coins to be used }

procedure TfEuro.mSettingsCoins5Click(Sender: TObject);

begin
  if not mSettingsCoins5.Checked then begin
    mSettingsCoins5.Checked  := True;
    mSettingsCoins10.Checked := False;
    mSettingsCoins15.Checked := False;
    mSettingsCoins20.Checked := False;
    bSettingsChanged := False;                                                 // note that new settings have not yet been applied
  end;
end;

procedure TfEuro.mSettingsCoins10Click(Sender: TObject);

begin
  if not mSettingsCoins10.Checked then begin
    mSettingsCoins5.Checked  := False;
    mSettingsCoins10.Checked := True;
    mSettingsCoins15.Checked := False;
    mSettingsCoins20.Checked := False;
    bSettingsChanged := False;
  end;
end;

procedure TfEuro.mSettingsCoins15Click(Sender: TObject);

begin
  if not mSettingsCoins15.Checked then begin
    mSettingsCoins5.Checked  := False;
    mSettingsCoins10.Checked := False;
    mSettingsCoins15.Checked := True;
    mSettingsCoins20.Checked := False;
    bSettingsChanged := False;
  end;
end;

procedure TfEuro.mSettingsCoins20Click(Sender: TObject);

begin
  if not mSettingsCoins20.Checked then begin
    mSettingsCoins5.Checked  := False;
    mSettingsCoins10.Checked := False;
    mSettingsCoins15.Checked := False;
    mSettingsCoins20.Checked := True;
    bSettingsChanged := False;
  end;
end;

{ Menu item "Einstellungen > Geldsumme anzeigen": Choose to display or not the "so far" money amount }

procedure TfEuro.mSettingsShowClick(Sender: TObject);

begin
  if mSettingsShow.Checked then
    mSettingsShow.Checked := False
  else
    mSettingsShow.Checked := True;
end;

{ Menu item "Hilfe > Über": Display application about }

procedure TfEuro.mHelpAboutClick(Sender: TObject);

var
  S: string;

begin
  S := 'Arithmetische Spielereien: Rechnen mit Euromünzen.' + LineEnding + LineEnding;
  S += '© allu, April, 2019.';
  MessageDlg('Über "Euro"', S, mtInformation, [mbOK], 0);
end;

{ Button "Start/Weiter": Generate a new question }

procedure TfEuro.btStartClick(Sender: TObject);

var
  I: Integer;

begin
  if not bSettingsChanged then begin
    // Display warning if user changed settings without starting a new game
    MessageDlg('Spieleinstellungen', 'Damit die Einstellungsänderungen aktiv werden, bitte "Neu" im Menü "Spiel" wählen!', mtWarning, [mbOK], 0);
    bSettingsChanged := True;
  end;
  if btStart.Caption = 'Weiter' then
    // Be sure evaluation values are up to date (user may have not answered at all the previous question!)
    UpdateEval(iQuestion, iCorrect);
  // Remove all coins from the left box (and set coin value in corr. array to 0)
  for I := 1 to 20 do begin
    imCoins[I].Visible := False;
    aCoinsValues[I] := 0;
  end;
  // Clear form fields / reset values
  edUAmount.Text := '';
  imEval.Visible := False;
  iUserCoins := 0; iUserAmount := 0;
  // Generate question
  Inc(iQuestion);
  iCoins := Random(iMaxCoins - iMinCoins + 1) + iMinCoins;                     // (random) number of coins to be used
  // Continue choosing random coins until the sum of their values is less or equal the max. amount selected
  repeat
    I := 0; iAmount := 0;
    repeat
      Inc(I);
      aCoins[I] := CoinsValues[Random(8)];
      iAmount += aCoins[I];
    until (I = iCoins) or (iAmount > iMaxAmount);                              // break if the wanted number of coins is reached or the coins sum exceed max. selected
  until iAmount <= iMaxAmount;                                                 // if the coins sum is ok (only possible with correct number of coins; cf. condition before), it's done!
  // Display number of coins to be used and amount to be reached
  edCoins.Text := IntToStr(iCoins);
  if iAmount < 100 then begin                                                  // display as cents
    edAmount.Text := IntToStr(iAmount);
    laUnit.Caption := 'Cent';
  end
  else begin                                                                   // display as euros
    edAmount.Text := FloatToStrF(iAmount / 100, ffFixed, 0, 2);
    laUnit.Caption := 'Euro';
  end;
  // Button settings for game continuation
  btStart.Caption := 'Weiter'; btDone.Enabled := True;
end;

{ Button "Fertig": Check user's answer }

procedure TfEuro.btDoneClick(Sender: TObject);

begin
  // If both the number of coins and the sum of the coins' values are equal to the given values, the user's answer is correct
  if (iUserCoins = iCoins) and (iUserAmount = iAmount) then begin
    Inc(iCorrect);
    imEval.Picture.LoadFromFile('correct.png');
    imEval.Visible := True;
  end
  // Otherwise, it's false
  else begin
    imEval.Picture.LoadFromFile('false.png');
  end;
  imEval.Visible := True;
  // Update evaluation values
  UpdateEval(iQuestion, iCorrect);
  // Disable "Fertig" button
  btDone.Enabled := False;
end;

{ Coin selections (user clicking coin in right box): Call procedure to display coin in left box }

procedure TfEuro.imCents1Click(Sender: TObject);

begin
  CoinClick(iAmount, iCoins, 1, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCents2Click(Sender: TObject);

begin
  CoinClick(iAmount, iCoins, 2, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCents5Click(Sender: TObject);

begin
  CoinClick(iAmount, iCoins, 5, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCents10Click(Sender: TObject);

begin
  CoinClick(iAmount, iCoins, 10, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCents20Click(Sender: TObject);

begin
  CoinClick(iAmount, iCoins, 20, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCents50Click(Sender: TObject);

begin
  CoinClick(iAmount, iCoins, 50, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imEuros1Click(Sender: TObject);

begin
  CoinClick(iAmount, iCoins, 100, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imEuros2Click(Sender: TObject);

begin
  CoinClick(iAmount, iCoins, 200, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

{ Coin removals (user clicking coin in left box): Call procedure to remove (hide) coin in left box }

procedure TfEuro.imCoins1Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 1, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins2Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 2, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins3Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 3, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins4Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 4, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins5Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 5, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins6Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 6, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins7Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 7, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins8Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 8, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins9Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 9, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins10Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 10, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins11Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 11, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins12Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 12, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins13Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 13, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins14Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 14, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins15Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 15, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins16Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 16, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins17Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 17, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins18Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 18, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins19Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 19, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

procedure TfEuro.imCoins20Click(Sender: TObject);

begin
  UserCoinClick(iAmount, 20, iUserCoins, iUserAmount, aCoinsValues, imCoins);
end;

end.

